# A function to calculate the new Csquared measure
# Given a weight matrix
Csquared = function(observed, predicted, W){
    n = length(observed)
    W = W/rowSums(W)
    Ws = sum(W)
    rawCen = observed-mean(observed) #Mean centered raw data
    margSpatCov = sum(W*tcrossprod(rawCen))/Ws+ var(rawCen)/n # Marginal spatial autocovariance
    resids = observed-predicted#Raw residuals
    condSpatCov = sum(W*tcrossprod(resids))/Ws + var(resids)/n # Conditional spatial autocovariance
    C2 = 1-condSpatCov/margSpatCov
    return(C2)
}
#Given a location matrix
CsquaredLoc = function(observed, predicted, location){
    weightMat = 1/as.matrix(dist(location[, c("x", "y")])); diag(weightMat) = 0
    Csquared(observed, predicted, weightMat)
}