#Addd facet titles using gtable
addFacetTitle = function(p, topLegend = !is.null(p$theme$legend.position) && p$theme$legend.position =="top", Return  =FALSE){
    # Check the layout    #  New strip at the top
    z <- ggplotGrob(p)
    #gtable_show_layout(z)   # New strip goes into row 7
    if(topLegend){
        tCol=8; bCol=9; lCol=5; rCol=11
        tRow=11; bRow=17; lRow=16; rRow=17
        rowPos = 8;colPos = 17
        Heights = unit(0.626784627092846, "cm")
    } else{
        tCol=7; bCol=7; lCol=5; rCol=15
        tRow=9; bRow=19; lRow=17; rRow=17
        rowPos =6; colPos = 16
        Heights = z$heights[7]
    }
    # New strip spans columns 5 to 9
    z <- gtable_add_rows(z, Heights, pos = rowPos)  # New row added below row
    z <- gtable_add_grob(z,
                         list(rectGrob(gp = gpar(col = NA, fill = "gray85", size = .5)),
                              textGrob("Spatial structure of the regressor", gp = gpar(cex = .75, fontface = 'bold', col = "black"))),
                         t = tCol, l = lCol, b = bCol, r = rCol, name = c("a", "b"))
    z <- gtable_add_cols(z, Heights, pos = colPos)  # New row added below row 6
    z <- gtable_add_grob(z,
                         list(rectGrob(gp = gpar(col = NA, fill = "gray85", size = .25)),
                              textGrob("Spatial structure of the outcome", rot = -90, gp = gpar(cex = .75, fontface = 'bold', col = "black"))), t = tRow, l = lRow, b = bRow, r = rRow, name = c("a", "b"))
    # Add small gap between strips - below row 6
    z <- gtable_add_rows(z, unit(2/10, "line"), 0)
    z <- gtable_add_cols(z, unit(2/10, "line"), 0)
    # Draw it
    grid.newpage();grid.draw(z)
    if(Return)
        return(z)
}

#Custom function for yield
addFacetTitleCaseStudy = function(p, Return = FALSE){
    z <- ggplotGrob(p)
    tCol=6; bCol=8; lCol=5; rCol=11
    tRow=11; bRow=17; lRow=13; rRow=17
    rowPos =6; colPos = 15
    Heights = z$heights[7]
    # New strip spans columns 5 to 9
    z <- gtable_add_rows(z, Heights, pos = rowPos)  # New row added below row
    z <- gtable_add_grob(z,
                         list(rectGrob(gp = gpar(col = NA, fill = "gray85", size = .5)),
                              textGrob("Test set", gp = gpar(cex = .75, fontface = 'bold', col = "black"))),
                         t = tCol, l = lCol, b = bCol, r = rCol, name = c("a", "b"))
    z <- gtable_add_cols(z, Heights, pos = colPos)  # New row added below row 6
    z <- gtable_add_grob(z,
                         list(rectGrob(gp = gpar(col = NA, fill = "gray85", size = .25)),
                              textGrob("Training set", rot = -90, gp = gpar(cex = .75, fontface = 'bold', col = "black"))), t = tRow, l = lRow, b = bRow, r = rRow, name = c("a", "b"))
    # Add small gap between strips - below row 6
    z <- gtable_add_rows(z, unit(2/10, "line"), rowPos)
    z <- gtable_add_cols(z, unit(2/10, "line"), colPos)
    # Draw it
    grid.newpage();grid.draw(z)
    if(Return)
        return(z)
}