fitInla = function(df, method = c("AR1", "Matern"), regs = "b", outVar = "a"){
    method = match.arg(method)
    switch(method,
           "AR1" = {model  = paste(paste(outVar, "~", paste(regs, collapse = "+")), "+
        f(x , model = 'ar1', control.group = list(model = 'ar1')) +
        f(y , model = 'ar1', control.group = list(model = 'ar1'))")
    # Run inla
    fitInlaAR1 = inla(formula = as.formula(model),  data = df)
    summary(fitInlaAR1)
           },
    "Matern" = {
    # ---- MODEL Single trial - SPDE ---- Gaussian random field
    Mesh = inla.mesh.2d(loc = df[, c("x", "y")], max.edge = Inf)
    SpdeStat = inla.spde2.matern(mesh = Mesh)
    MeshIndex = inla.spde.make.index(name = "FieldI", n.spde = SpdeStat$n.spde)
    # Map the locations to the mesh
    APlots = inla.spde.make.A(Mesh, loc = as.matrix(df[, c("x", "y")]), index = c(1:nrow(df)))
    # Store the data, the A matrix and the effects in a stack object
    stack = inla.stack(data = df, A = list(APlots),
                       effects = list(c(MeshIndex, list(intercept = 1))),
                       tag = "Estimate")
    modelSpde = paste(paste(outVar, "~", paste(regs, collapse = "+")), "+ f(FieldI, model = SpdeStat)")
    # Run inla
    FitSPDE  = inla(formula = as.formula(modelSpde),  data = inla.stack.data(stack),
                    control.predictor = list(A = inla.stack.A(stack)))
    summary(FitSPDE)})
}