#Fit pls for a single lambda
fitPLSsingle = function(x, y, alpha, keep, lambda, soCor, kernelData, glsSt, optControl, xNames, kSpline = 5, cv =FALSE, nlambda = NULL, outVar = "a",...){
    switch(soCor,
           "None" = {
               fit = glmnet(x = x, y = y, alpha = alpha, keep = keep, lambda = lambda, nlambda = nlambda)
               fit$corMat = diag(nrow(kernelData))
               return(fit)
           },
           "Weighted" ={
               margCorMat = getMargCorMat(kernelData = kernelData, form = formula(paste(outVar, "~1")), outVar = outVar, correlation  = corStruct, control = optControl, corr = TRUE)
               fit = glmnet(x = x, y = y, intercept = TRUE, alpha = alpha, keep = keep, lambda = lambda, weights = 1/diag(solve(margCorMat)))
               fit$corMat = margCorMat
               return(fit)
           },
           "Puffer" ={
               xSvd = svd(x)
               Puffer = xSvd$u %*% diag(1/xSvd$d) %*% t(xSvd$u)
               desMat = Puffer %*% cbind(y, x)
               fit = glmnet(x = desMat[,-1], y = desMat[,1], intercept = TRUE, alpha = alpha, keep = keep, lambda = lambda)
               fit$corMat = Puffer
               return(fit)
           },
           "Marginal"= {
               margCorMat = getMargCorMat(kernelData = kernelData, glsSt = glsSt,
                                          control = optControl, outVar = outVar)$corMat
               desMat = margCorMat %*% cbind(y, x)
               fit = glmnet(x = desMat[,-1], y = desMat[,1], intercept = TRUE,
                            alpha = alpha, keep = keep, lambda = lambda)
               fit$corMat = margCorMat
               return(fit)
           },
           "Conditional" = pgls(data = kernelData, glsSt = glsSt, outVar = outVar,
                         optControl = optControl, xNames = xNames, alpha = alpha,
                         lambda = lambda, keep = keep, ...)
           ,
           "GAM" = {
               kernelData$X = as.matrix(kernelData[, xNames])
               fit = gamlasso(formula = formula(paste0(outVar, "~X+ te(x,y, k =", kSpline, ",bs = c('tp','tp'))")), num.iter = 1e2,
                              alpha = alpha, keep = keep, lambda = lambda, smooth.penalty = "l1", data = kernelData, cv = cv, verbose = FALSE,...)
                fit$corMat = diag(nrow(kernelData))
                return(fit)
           },
           "sf" = {
               meig <- suppressMessages(meigen(coords = kernelData[, c("x", "y")]))
               fit = glmnet(x = cbind(x, meig$sf), y = y, alpha = alpha, keep = keep, lambda = lambda)
               #Also do model selection on eigenvalues
               fit$corMat = diag(nrow(kernelData))
               return(fit)
           },
           "inlaAR1" = {
               fit =  fitInla(kernelData, method = "AR1", regs = xNames, outVar = outVar)
           }
           ,
           "inlaMatern" = {
               fit =  fitInla(kernelData, method = "Matern", regs = xNames, outVar = outVar)
           }
    )
}