#Fit simultaneous autoregressive model
fitSAR = function(df, regs = "b", k = 8, d2 = max(dist(df[, c("x", "y")]))/5, neighbour = "knn", outVar = "a"){
    #Maximum distance is one third the range of the grid
    finalForm = formula(paste(outVar, "~", paste(regs, collapse = "+")))
    nb = switch(neighbour,
                "distance" = dnearneigh(as.matrix(df[, c("x", "y")]), 0, d2 = d2),
                "knn" = knearneigh(as.matrix(df[, c("x", "y")]), k = k))
    lw <- switch(neighbour,
                 "distance" =spdep::nb2listw(nb, style="W"),
                 "knn" = nb2listw(knn2nb(nb)))
    ev <- spatialreg::eigenw(lw)
    do.call(spatialreg::errorsarlm, list(finalForm, data = df,
                                           lw, quiet=TRUE, control=list(pre_eig=ev)))
}