#Make data with gaussian kernel for correlation
genKernelData = function(gridSize, n, p, predFrac, autoCorrFrac, sdBetas, depTypeReg, depTypeResp,
                         kernelMult = gridSize, grid = NULL, betas = NULL, sdReg = 1, sdResp = 1){
    if(is.null(grid)){
        grid = expand.grid("x" = seq_len(gridSize), "y" = seq_len(gridSize))
    }
    drawId = sample(gridSize^2, n)
    grid = grid[drawId,]
    #List true and false pos and neg
    ntpKernel = round(p*predFrac*autoCorrFrac)
    ntpId = round(p*predFrac*(1-autoCorrFrac))
    nfpKernel = round(p*(1-predFrac)*autoCorrFrac)
    nfpId = round(p*(1-predFrac)*autoCorrFrac)
    #drawParameters
    betas = if(is.null(betas)) c(rnorm(ntpKernel + ntpId, sd = sdBetas), numeric(nfpKernel + nfpId)) else betas
    names(betas) = paste0("b.", rep(c("TPkernel", "TPiid", "TNkernel", "TNiid"), times = c(ntpKernel, ntpId, nfpKernel, nfpId)))
    regtpKernel = sapply(integer(ntpKernel), function(foo){
        rmvnorm(1, drawKernel(gridSize, grid = grid, depType = depTypeReg, kernelMult = kernelMult),
                            sigma = sdReg *getCorMat(grid, depTypeReg, csList))})
    regtpiid = t(rmvnorm(ntpId, drawKernel(gridSize, grid = grid, depType = "none"),
                            sigma = sdReg *getCorMat(grid, "none", csList)))
    regtpnKernel = sapply(integer(nfpKernel), function(foo){
        rmvnorm(1, drawKernel(gridSize, grid = grid, depType = depTypeReg, kernelMult = kernelMult),
                sigma = sdReg *getCorMat(grid, depTypeReg, csList))})
    regtniid = t(rmvnorm(nfpId, drawKernel(gridSize, grid = grid, depType = "none"),
                            sigma = sdReg *getCorMat(grid, "none", csList)))

    x = cbind(regtpKernel, regtpiid, regtpnKernel, regtniid)
    yKernel = drawKernel(gridSize, grid = grid, depType = depTypeResp, kernelMult = kernelMult)
    meanY = yKernel + x %*% betas
    y = t(rmvnorm(1, meanY, sigma = sdResp *getCorMat(grid, depTypeResp, csList)))
    y = (y-mean(y))
    colnames(x) =  names(betas)
    df = data.frame("a"= y, x, grid)
    attr(df, "betas") = betas
    attr(df, "meanY") = meanY
    return(df)
}