#Extract condition number from a fit
getCondNum = function(fit, kernelData, corStruct, soCor){
    xNames = grep(names(kernelData), pattern = "b.", value = TRUE)
    rawDesMat = as.matrix(cbind(1,kernelData[, xNames]))
    desMat = switch(soCor,
                    "None" = rawDesMat,
                    "Marginal"= {
                        margCorMat = getMargCorMat(kernelData = kernelData, glsSt  = glsStruct(corStruct),
                                                   control = optControl)$corMat
                        margCorMat %*% rawDesMat
                    },
                    "Conditional" = {
                        corMat = corMatrix(fit$modelStruct$corStruct, corr = FALSE)
                        corMat %*% rawDesMat
                    },
                    "GAM" = model.matrix(fit),
                    "sar" = {
                        d2 = max(dist(kernelData[, c("x", "y")]))/3
                        nb = dnearneigh(as.matrix(kernelData[, c("x", "y")]), 0, d2 = d2)
                        lw <- spdep::nb2listw(nb, style="W")
                        W <- as(lw, "CsparseMatrix")
                        (if(fit$lambda<0) diag(ncol(W)) else getInvSqrt(fit$lambda*W)) %*% rawDesMat
                    },
                    {meig <- suppressMessages(meigen(coords = kernelData[, c("x", "y")]))
                    as.matrix(cbind(1, kernelData[, xNames], meig$sf[, as.numeric(gsub("sf", "", rownames(fit$r)))]))
                    }
    )
    kappa(crossprod(desMat))
}