#Help functions for Moran's I calculation
.getW <- function(modelData) {
    d <- dist(modelData[, c("gutter", "position")])
    w <- 1/(as.matrix(d))
    diag(w) <- 0
    w
}
#Get Moran's I
getMoranI = function(model, data, id, w = NULL){
    if(is.null(w))
        w <- .getW(data)
    normalized.r <- residuals(model, type = switch(class(model), "lme" = "normalized", "lm" = "pearson"))
    ape::Moran.I(normalized.r[id], w)
}
