#A fast calculation of observed Moran's I
moransIobs = function(x, W, normalize = TRUE, center = FALSE){
    n = length(x)
    if(normalize)
        W = W/rowSums(W)
    Ws = sum(W)
    rawCen = x-mean(x) #Mean centered raw data
    mI = sum(W*tcrossprod(rawCen))/sum(rawCen^2)*n/Ws #Moran's I
    if(center)
        mI = mI + 1/(n-1) #Center around zero
    return(mI)
}
#Given a location matrix
moransIobsLoc = function(x, Loc, toroidal = FALSE){
    distFunc = match.fun(if(toroidal) "dist.torus" else "dist")
    dd = distFunc(Loc[, c("x", "y")])
    weightMat = 1/as.matrix(dd); diag(weightMat) = 0
    moransIobs(x, weightMat)
}