#A plotting function for splitplots
plotSplitPlot = function(design, ...){
    splitPlotData = makeSplitPlotData(depTypeResp = "none", design = design, ...)
    ggplot(data = splitPlotData$data, aes(x = x, y = y, col = Condition)) +
        geom_point(size = 2) + #scale_color_brewer(palette = "Paired") +
        coord_fixed() + guides("colour" = guide_legend(ncol = 2)) +
        geom_hline(aes(yintercept = y), data = data.frame("y" = splitPlotData$colSplits + 0.5), linetype = "dashed")+
        geom_vline(aes(xintercept = y), data = data.frame("y" = splitPlotData$rowSplits + 0.5), linetype = "dashed")
}
makeSplitPlotData = function(depTypeResp, design, subPlotSize, n = round(nrow(spatialGrids[[design]])/2)){
    kernelData = makeSpatialDf(depTypeResp = depTypeResp, depTypeReg = "none", csList = csList,
                               n = n, grid = spatialGrids[[design]], p = 1, betas = 0) #Make data
    colSplits  = seq(subPlotSize, max(spatialGrids[[design]]$y)-subPlotSize, by = subPlotSize)
    rowSplits  = seq(subPlotSize, max(spatialGrids[[design]]$x)-subPlotSize, by = subPlotSize)
    kernelData = cbind(kernelData, splitPlot(kernelData, colSplits = colSplits, rowSplits = rowSplits))
    treatCoords = with(kernelData, plot[(col + sapply(row, function(x) which(x==LETTERS))) %%2 == 0])
    kernelData$CondNum = as.integer(kernelData$plot %in% treatCoords)
    kernelData$Condition = ifelse(kernelData$plot %in% treatCoords, "Treatment", "Control")
    list("data" = kernelData, "rowSplits" = rowSplits, "colSplits" = colSplits)
    }