#Spatial filtering fits
getSFfit = function(df, k, outVar = "a", Form = "a~b"){
    nb <- knn2nb(knearneigh(as.matrix(df[, c("x", "y")]), k=k))
    sfFit = spatialreg::SpatialFiltering(a~b, data = df, nb = nb, ExactEV = TRUE) #Find eigenvectors to condition on
    Form = paste(Form, "+", paste(colnames(sfFit$dataset), collapse = "+"))
    lm(Form, data = cbind(df, sfFit$dataset))
}
getSFfitspmoran = function(df, regs = "b", random = FALSE, outVar = "a"){
    meig <- suppressMessages(meigen(coords = df[, c("x", "y")]))
    regMat = model.matrix(formula(paste("~", paste(regs, collapse = "+"))), df)[,-1, drop = FALSE]
    res = if(random){
        suppressMessages(resf(y = df[[outVar]], x = regMat, meig = meig))
    } else {
        suppressMessages(esf(y = df[[outVar]], x = regMat, meig = meig))
    }
    res
}